@echo off
:: %1   N   No Ruby Syntax Check (to speed up)
::      Y   (Default) Syntax Check
:: %2   C   Run from combined jar file
::      S   (Default) Run from separate jar files

setlocal

chcp 1252 >NUL

call src_settings
echo GEM_HOME=%GEM_HOME% GEM_PATH=%GEM_PATH%

jruby --version

:: Needed for processing UTF8 characters. Note that this will produce for each
:: compiled file an annoying warning "Picked up JAVA_TOOL_OPTIONS". There does
:: not seem to exist a way to suppress this warning.
set JAVA_TOOL_OPTIONS=-Dfile.encoding=UTF8
:: Jar-File made from our application. For this batch file, it MUST be an absolute path
set jardir=%CD%\jars
set jarf_name=vp.jar
set jarf=%jardir%\%jarf_name%
:: Jar directory must exist, otherwise jar command will fail
if not exist %jardir% mkdir %jardir%
set rbdir=rbsrc
set jsrc=jsrc
:: set jclass=%vp%
set jclass=.

@echo Cleaning data from previous run
del *.class 2>NUL
del %jarf% 2>NUL
del out.txt 2>NUL
del ucout.txt 2>NUL

@echo Compile Java and entertain the user with silly 'Picked up JAVA_TOOL_OPTIONS' warnings
set JRUBY_JAR_NAME=jruby-complete-1.7.23.jar
set JRUBY_JAR=c:\dl\%JRUBY_JAR_NAME%
set CLASSPATH=.;%JRUBY_JAR%

::  -target 6 -source 6
for %%j in (%jsrc%\*.java) do javac -d . %%j & if ERRORLEVEL 1 goto :eof

if .%1 == .N goto :skip
echo Syntax check Ruby
:: This produces the warning
::    io/console not supported; tty will not be manipulated
:: with JRuby 1.7.23, no warning with JRuby 9.0.4.0
for %%f in (rbsrc/*.rb) do (echo %%f : & jruby -c %rbdir%\%%f : if ERRORLEVEL 1 goto :eof)
:skip

@echo Making jar
@echo on
type MANIFEST.MF
jar cvfm %jarf% MANIFEST.MF -C %jclass% Jmain.class vp\VP.class hostenv\HE.class kantan\Kantan.class ifkantan\IfKantan.class %rbdir% -C %LOCAL_GEM_DIR% .
@if ERRORLEVEL 1 goto :eof
dir %jarf%

@if .%2 == .C goto :combined

@echo Running the program from separate jar files and displaying the results
if defined RUN_IT_HERE goto :cpjar1
java -cp %JRUBY_JAR%;%jarf% Jmain
@goto :verify
:cpjar1
mkdir %RUN_IT_HERE% 2>NUL
set oldwd=%CD%
cd %RUN_IT_HERE%
if ERRORLEVEL 1 goto :eof
cd %oldwd%
copy %JRUBY_JAR% %RUN_IT_HERE%
copy %jarf% %RUN_IT_HERE%
cd %RUN_IT_HERE%
java -cp %JRUBY_JAR_NAME%;%jarf_name% Jmain
@goto :verify

:combined
@echo combining into a single jar file
@echo off
set TEMPDIR=jctmp
set OLDWD=%CD%
set COMBJAR=%CD%\jars\combined.jar
if not exist %TEMPDIR% mkdir %TEMPDIR%
cd %TEMPDIR%
if ERRORLEVEL 1 goto :eof
del /S /Q * >NUL
jar -xf %JRUBY_JAR%
jar -xf %jarf%
cd %OLDWD%
set COMB_MANIFEST=%TEMPDIR%\META-INF\MANIFEST.MF
@echo on
jar -cvfm %COMBJAR% %COMB_MANIFEST% -C %TEMPDIR% . >NUL
java -jar %COMBJAR%

:verify
@echo Verify existence and content of out.txt and ucout.txt:
type out.txt
type ucout.txt

@echo DONE
